#include <iostream>
#include <limits.h>

using namespace std;

const int maxN = 80002;

int NajkraceRastojanje(int udaljenosti[maxN][maxN], bool naPutu[], int n, int x)
{
    int min1 = INT_MAX, indexMin;
    for (int i = 1; i <= n; i++)
    {
        if (naPutu[i] == false && udaljenosti[x][i] <= min1)
        {
            min1 = udaljenosti[x][i];
            indexMin = i;
        }
    }
    return indexMin;
}

int main()
{
    int n, i, j, u, v, q, max1;
    int grupa, a, b, l, r, x, p;
    int gradovi[maxN], matricaGrafa[maxN][maxN], udaljenosti[maxN][maxN];
    cin >> n;
    for(i=1; i<=n; i++)
    {
        cin >> gradovi[i];
        for(j=1; j<=n; j++)
        {
            matricaGrafa[i][j] = 0;
        }
        udaljenosti[i][i]=-1;
    }
    for(i=1; i<=n-1; i++)
    {
        cin >> u;
        cin >> v;
        matricaGrafa[u][v] = 1;
        matricaGrafa[v][u] = 1;
    }
    cin >> q;
    while(q--)
    {
        cin >> grupa;
        if(grupa==1)
        {
            cin >> a;
            cin >> b;
            p = gradovi[a];
            gradovi[a] = gradovi[b];
            gradovi[b] = p;
        }
        else
        {
            cin >> l;
            cin >> r;
            cin >> x;
            if(udaljenosti[x][x]==-1)
            {
                bool naPutu[maxN];
                for (i = 1; i <= n; i++)
                {
                    udaljenosti[x][i] = INT_MAX;
                    naPutu[i] = false;
                }
                udaljenosti[x][x] = 0;
                for (i = 1; i <= n; i++)
                {
                    int u = NajkraceRastojanje(udaljenosti, naPutu, n, x);
                    naPutu[u] = true;

                    for (int v = 1; v <= n; v++)
                    {
                        if (!naPutu[v] && matricaGrafa[u][v] && udaljenosti[x][u] != INT_MAX && udaljenosti[x][u] + matricaGrafa[u][v] < udaljenosti[x][v])
                        {
                            udaljenosti[x][v] = udaljenosti[x][u] + matricaGrafa[u][v];
                        }
                    }
                }

                max1 = udaljenosti[x][l];
                for(i=l+1;i<=r;i++)
                {
                    if(udaljenosti[x][gradovi[i]]>max1)
                    {
                        max1 = udaljenosti[x][i];
                    }
                }
                cout << max1 << endl;

            }
            else
            {
                max1 = udaljenosti[x][l];
                for(i=l+1;i<=r;i++)
                {
                    if(udaljenosti[x][gradovi[i]]>max1)
                    {
                        max1 = udaljenosti[x][i];
                    }
                }
                cout << max1 << endl;
            }
        }
    }
}